Magellan Linux

Diff of /tags/installer-simple-0_4_90_20140703_1/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2344 by niro, Fri Jan 3 15:01:06 2014 UTC revision 2439 by niro, Tue Jan 7 14:37:35 2014 UTC
# Line 16  INSTALLER_LIBDIR="%LIBDIR%" Line 16  INSTALLER_LIBDIR="%LIBDIR%"
16  # -> now in images.conf  # -> now in images.conf
17  CURRENTLINE=0  CURRENTLINE=0
18    
19  # configuration  die()
20  if [ -e %SYSCONFDIR%/installer.conf ]  {
21  then   echo "Error: $@"
22   source %SYSCONFDIR%/installer.conf   exit 1
23  else  }
24   die "/etc/installer.conf not found"  
25  fi  # load common includes
26    for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/bootloader.sh \
31     ${INSTALLER_LIBDIR}/functions/initrd-tools.sh \
32     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
33    do
34     if [ -e ${inc} ]
35     then
36     source "${inc}"
37     else
38     die "'${inc}' not found"
39     fi
40    done
41    
42  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
43  # -> now in images.conf  # -> now in images.conf
# Line 39  else Line 54  else
54   die "/mnt/cdrom/system/images.conf not found"   die "/mnt/cdrom/system/images.conf not found"
55  fi  fi
56    
 # includes  
 source ${INSTALLER_LIBDIR}/functions/hwdetection.sh  
   
57  ### System/Config Version  ### System/Config Version
58  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
59  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
60    
61    # some sane defaults
62  CDROOT="${DEFAULT_CDROOT}"  CDROOT="${DEFAULT_CDROOT}"
63  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
64    KERNELPKG="${DEFAULT_KERNELPKG}"
65  # standard kernel opts  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
66  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
67  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
68  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
69  SPECIALDEVICE=""  SPECIALDEVICE=""
70  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
71  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
72    
73  #################################################  #################################################
74  #  DIALOG BOXEN #  #  DIALOG BOXEN #
75  #################################################  #################################################
76    
77  die()  trap_exit()
78  {  {
79   echo "Error: $@"   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
80     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
81     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
82     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
83     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
84    
85     echo $"Installation aborted."
86   exit 1   exit 1
87  }  }
88    
# Line 86  dialog_die() Line 96  dialog_die()
96    
97  dialog_warning()  dialog_warning()
98  {  {
99   dialog \   local retval
100   --backtitle "${TITLE}" \  
101   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
102   --defaultno \   retval=$?
103   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
104   then   then
105   clear   clear
106   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
107   exit 1   exit 1
108   fi   fi
109  }  }
110    
111  dialog_setup_hdd_info()  dialog_setup_hdd_info()
112  {  {
113   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
114    
115   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
116   --colors \   $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
117  }  }
118    
119  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
120  {  {
121   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
122    
123   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
124   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
125  }  }
126    
127  dialog_setup_system_menu()  dialog_setup_system_menu()
128  {  {
129   local i   local mode
130     local retval
131    
132   i=$(dialog \   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
133   --backtitle "${TITLE}" \   $"1:Automatic setup (recommended)" \
134   --title "[ Festplatten Partitionierung ]" \   ":" \
135   --cancel-label "Abbrechen" \   $":\Z1Expert modes:\Zn" \
136   --ok-label "Weiter" \   $"2:Common IDE-disk (manual setup)")
137   --stdout \   retval=$?
138   --colors \   [[ ${retval} -eq 1 ]] && return 1
139   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \   if [[ ${retval} -eq 0 ]]
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
140   then   then
141   case "${i}" in   case "${mode}" in
142   "1") run_install_auto ;;   "1") run_install_auto ;;
143   "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
144   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
145   esac   esac
146   fi   fi
# Line 177  dialog_setup_system_menu() Line 148  dialog_setup_system_menu()
148    
149  dialog_hardware_detection()  dialog_hardware_detection()
150  {  {
151   local i   local message
  local hwtmp  
   
  if [ -x $(which mktemp &> /dev/null) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
152    
153   run_hardware_detection_disks   run_hardware_detection_disks
154    
155   echo "dialog \\"  > ${hwtmp}   message+=$"Harddrives:\n"
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
156    
157   if [[ ! -z ${ALL_DISKS} ]]   if [[ ! -z ${ALL_DISKS} ]]
158   then   then
159   for i in ${ALL_DISKS}   for i in ${ALL_DISKS}
160   do   do
161   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}   message+="\Z3${i}\Zn "
162   done   done
163     message+="\n"
164   fi   fi
165    
166   if [[ ! -z ${ALL_CDROMS} ]]   if [[ ! -z ${ALL_CDROMS} ]]
167   then   then
168   echo " \n \\" >> ${hwtmp}   message+="\n"
169   echo " CDROM Laufwerke:\n \\" >> ${hwtmp}   message+=$"Optical disk drives:\n"
170   for i in ${ALL_CDROMS}   for i in ${ALL_CDROMS}
171   do   do
172   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}   message+="\Z3${i}\Zn"
173   done   done
174     message+="\n"
175   fi   fi
176    
177   # other devices   # other devices
178   run_hardware_detection   run_hardware_detection
179   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
180   zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
181   rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
182   maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;   maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
183   *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;   *) message+=$"\n \\ZnCommon device detected.\Zn" ;;
184   esac   esac
185   if [[ ${FORMFACTOR} = laptop ]]   if [[ ${FORMFACTOR} = laptop ]]
186   then   then
187   echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"
188   fi   fi
189    
190   echo " \" 14 70" >> ${hwtmp}   messagebox -y 15 -h $"Detected hardware:" "${message}"
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
191  }  }
192    
193  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
194  {  {
195   local i   local i
196     local retval
197    
198   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
199   then   then
200   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
201   exit 1   exit 1
202   else   else
203     HDD=$(dialog_select_target_harddrive)
204   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
205   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
206   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
207   then   then
208   dialog_setup_hdd_info   dialog_setup_hdd_info
209   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell_flash()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_flash  
  setup_hdd_partitions_manuell_flash  
210   fi   fi
211   fi   fi
212  }  }
# Line 318  dialog_setup_hdd_partitions_manuell_flas Line 214  dialog_setup_hdd_partitions_manuell_flas
214  dialog_setup_hdd_partitions_auto()  dialog_setup_hdd_partitions_auto()
215  {  {
216   local i   local i
217     local retval
218    
219   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
220   then   then
221   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
222   exit 1   exit 1
223   else   else
224     HDD=$(dialog_select_target_harddrive)
225   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
226   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
227   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
228   then   then
229   dialog_setup_hdd_info_auto   dialog_setup_hdd_info_auto
230   dialog_setup_hdd_create_partitions   dialog_setup_hdd_create_partitions
# Line 354  dialog_setup_hdd_partitions_auto() Line 233  dialog_setup_hdd_partitions_auto()
233   fi   fi
234  }  }
235    
236  run_hardware_detection_disks()  install_meter()
 {  
  local bootdev  
   
  # all disks but exclude ramdisks  
  export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')  
  # remove the boot device from ALL_DISKS if it was an usbstick  
  if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]  
  then  
  bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"  
  export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")  
  fi  
  export ALL_CDROMS="$(get_hwinfo cdrom)"  
 }  
   
 dialog_setup_hdd_create_partitions()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
   
 dialog_setup_hdd_format()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
   
 dialog_install_settings()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Speichere System-Einstellungen ..." 3 70  
 }  
   
 dialog_install_system_image()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --gauge "Kopiere System-Image ..." 6 80  
 }  
   
 dialog_install_meter()  
237  {  {
238   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
239   do   do
# Line 410  dialog_install_meter() Line 246  dialog_install_meter()
246   return 0   return 0
247  }  }
248    
   
 dialog_install_bootsector()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
   
 dialog_install_successful()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81  
 }  
   
 dialog_install_failure()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
 }  
   
249  dialog_main()  dialog_main()
250  {  {
251   METHOD=0   local method=0
252     local retval
253    
254   while [[ ${METHOD} -le 2 ]]   while [[ ${method} -le 2 ]]
255   do   do
256   METHOD=$(dialog \   method=$(menubox $"Configuration:" \
257   --backtitle "${TITLE}" \   $"1:Install system" \
258   --no-cancel \   $"2:Show detected harddrives" \
259   --ok-label "Weiter" \   $"3:Exit and reboot" \
260   --stdout \   $"4:Exit and drop into a shell")
261   --menu "Konfiguration" 14 70 5 \   retval=$?
262   "1" "AutoSta_LX installieren" \   [[ ${retval} -eq 1 ]] && exit 1
263   "2" "Uebersicht gefundener Laufwerke" \   if [[ ${retval} -eq 0 ]]
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
264   then   then
265   case ${METHOD} in   case ${method} in
266   "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
267   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
268   "3") install_do_reboot ;;   "3") install_do_reboot ;;
# Line 475  run_hardware_detection() Line 281  run_hardware_detection()
281    
282   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"   hwinfo="$(hwinfo --bios --storage --pci --gfxcard --sys)"
283    
284   # check for special devices/clients:   ## check for special devices/clients:
285   # if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd   ## if zotac a zotac and the disk is a removeable device, then add rootdelay to kernelcmd
286   local removable=0   #local removable=0
287   if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]   #if [[ ! -z $(echo "${hwinfo}" | grep -i zotac) ]]
288   then   #then
289   for i in /sys/block/[hs]d*/removable   #for i in /sys/block/[hs]d*/removable
290   do   #do
291   if [[ $(< ${i}) = 1 ]]   #if [[ $(< ${i}) = 1 ]]
292   then   #then
293   removable=1   #removable=1
294   fi   #fi
295   done   #done
296     ## smartcard = udevadm info -n /dev/sda -a | grep -i 'configuration.*card'
297   # only add this for grub legacy, grub2 detect these settings on its own  
298   export GRUBLEGACYOPTS="rootdelay=8"   ## only add this for grub legacy, grub2 detect these settings on its own
299   # there are to zotac types in the wild, nvidia based gfx and intel   #export GRUBLEGACYOPTS="rootdelay=8"
300   if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]   ## there are to zotac types in the wild, nvidia based gfx and intel
301   then   #if [[ ! -z $(echo "${hwinfo}" | grep -i nouveau) ]]
302   export SPECIALDEVICE="zotac_nvidia"   #then
303   else   #export SPECIALDEVICE="zotac_nvidia"
304   export SPECIALDEVICE="zotac_intel"   #else
305   fi   #export SPECIALDEVICE="zotac_intel"
306   fi   #fi
307     #fi
308    
309   # check for special devices/clients:   # check for special devices/clients:
310   # if a rangee and disk ist smaller then 256mb move partion one block further ahead   # if a rangee and disk ist smaller then 256mb move partion one block further ahead
# Line 526  run_hardware_detection() Line 333  run_hardware_detection()
333   fi   fi
334  }  }
335    
336    run_hardware_detection_disks()
337    {
338     local bootdev
339    
340     # all disks but exclude ramdisks
341     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
342     # remove the boot device from ALL_DISKS if it was an usbstick
343     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
344     then
345     bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
346     export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
347     fi
348     export ALL_CDROMS="$(get_hwinfo cdrom)"
349    }
350    
351  hdd_size_below_256mb()  hdd_size_below_256mb()
352  {  {
353   local hdd="$1"   local hdd="$1"
# Line 548  setup_hdd_partitions_auto() Line 370  setup_hdd_partitions_auto()
370  {  {
371   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
372    
373     # sanity check - should not happen
374     if is_mounted --device "${ROOTHDD}"
375     then
376     echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
377     umount "${ROOTHDD}"
378     fi
379    
380   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
381   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
382   then   then
# Line 606  EOF Line 435  EOF
435   fi   fi
436  }  }
437    
438  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || dialog_die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
439  {  {
440   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
441     SWAPHDD=""
442   ## hdds partitionieren manuell   BOOTHDD=""
443   cfdisk ${HDD} || dialog_die   cfdisk ${HDD} || dialog_die
444  }  }
445    
446  setup_hdd_format()  setup_hdd_format()
447  {  {
448   mkswap ${SWAPHDD} || dialog_die   # sanity check - should not happen
449   mke2fs -j -q ${BOOTHDD} || dialog_die   if is_mounted --device "${ROOTHDD}"
450   mke2fs -j -q ${ROOTHDD} || dialog_die   then
451  }   echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
452     umount "${ROOTHDD}"
453     fi
454    
455  setup_hdd_format_flash()   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
 {  
  mke2fs -j -q ${ROOTHDD} || dialog_die  
456  }  }
457    
458  install_mount_rootfs()  install_mount_rootfs()
459  {  {
460   swapon ${SWAPHDD} || dialog_die   is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
  install -d ${INSTALLROOT}/boot || dialog_die  
  mount ${BOOTHDD} ${INSTALLROOT}/boot || dialog_die  
  cd ${INSTALLROOT} || dialog_die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
461   install -d ${INSTALLROOT}/boot || dialog_die   install -d ${INSTALLROOT}/boot || dialog_die
  cd ${INSTALLROOT} || dialog_die  
462  }  }
463    
464  install_system_image()  install_system_image()
465  {  {
466     pushd ${INSTALLROOT} > /dev/null
467   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
468     popd > /dev/null
469  }  }
470    
471  install_bootsector_chroot()  install_bootsector_chroot()
# Line 758  exit 0 Line 569  exit 0
569  CHROOTEOF  CHROOTEOF
570   fi   fi
571    
572   ## enter chroot   # run installrc
573   mount -t proc proc ${INSTALLROOT}/proc   chrooted /bin/bash --rcfile /root/.installrc -i
  mount -t sysfs sysfs ${INSTALLROOT}/sys  
  mount -o bind /dev ${INSTALLROOT}/dev  
  chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLROOT}/proc  
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
574   rm ${INSTALLROOT}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
575  }  }
576    
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0  
  return 1  
 }  
   
577  install_initrd_chroot()  install_initrd_chroot()
578  {  {
579   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
# Line 818  mkinitrd -f /boot/$(readlink /boot/initr Line 616  mkinitrd -f /boot/$(readlink /boot/initr
616  exit 0  exit 0
617  CHROOTEOF  CHROOTEOF
618    
619   ## enters chroot   # run installrc
620   mount -t proc proc ${INSTALLROOT}/proc   chrooted /bin/bash --rcfile /root/.installrc -i
  mount -t sysfs sysfs ${INSTALLROOT}/sys  
  mount -o bind /dev ${INSTALLROOT}/dev  
  chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLROOT}/proc  
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
621   rm ${INSTALLROOT}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
622  }  }
623    
624  is_uuid_supported()  is_uuid_supported()
625  {  {
626   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
627   then   then
628   # only detect uuids if supported   # only detect uuids if supported
629   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 843  is_uuid_supported() Line 635  is_uuid_supported()
635   return 1   return 1
636  }  }
637    
 get_uuid()  
 {  
  local UUID  
  local SEC_TYPE  
  local TYPE  
   
  local dev="$1"  
  [[ -z ${dev} ]] && dialog_die "no dev given"  
   
  # check if given device is already an UUID  
  if [[ ${dev/UUID=/}x != ${dev}x ]]  
  then  
  eval "${dev}"  
  else  
  eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')  
  fi  
  echo "${UUID}"  
 }  
   
638  install_system_settings()  install_system_settings()
639  {  {
640   # schreibe fstab   # schreibe fstab
641   if is_uuid_supported   if is_uuid_supported
642   then   then
  echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die  
643   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
644   else   else
  echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die  
645   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
646   fi   fi
647   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
# Line 895  install_system_settings() Line 666  install_system_settings()
666   fi   fi
667  }  }
668    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
 }  
   
669  install_umount_rootfs()  install_umount_rootfs()
670  {  {
671   cd /   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
672   umount ${INSTALLROOT}/boot || dialog_die   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
  umount ${INSTALLROOT} || dialog_die  
  swapoff ${SWAPHDD} || dialog_die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLROOT} || dialog_die  
673  }  }
674    
675  install_do_reboot()  install_do_reboot()
# Line 935  run_install_normal() Line 685  run_install_normal()
685  {  {
686   dialog_hardware_detection   dialog_hardware_detection
687    
688   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
689   dialog_setup_hdd_format   dialog_setup_hdd_format
690   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
691   install_mount_rootfs   install_mount_rootfs
692   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
693    
694   dialog_install_settings   dialog_install_settings
695   sleep 1   sleep 1
696   install_system_settings   install_system_settings
697     dialog_install_initrd
698   install_initrd_chroot   install_initrd_chroot
699    
700   dialog_install_bootsector   dialog_install_bootsector
# Line 953  run_install_normal() Line 704  run_install_normal()
704   dialog_install_successful   dialog_install_successful
705  }  }
706    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
707  run_install_auto()  run_install_auto()
708  {  {
709   dialog_hardware_detection   dialog_hardware_detection
710    
711   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
712   dialog_setup_hdd_format   dialog_setup_hdd_format
713   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
714   install_mount_rootfs_flash   install_mount_rootfs
715   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
716    
717   dialog_install_settings   dialog_install_settings
718   sleep 1   sleep 1
719   install_system_settings_flash   install_system_settings
720     dialog_install_initrd
721   install_initrd_chroot   install_initrd_chroot
722    
723   dialog_install_bootsector   dialog_install_bootsector
724   install_bootsector_chroot   install_bootsector_chroot
725    
726   install_umount_rootfs_flash   install_umount_rootfs
727   dialog_install_successful   dialog_install_successful
728  }  }
729    
730    # set some proper traps
731    trap "trap_exit" SIGINT SIGQUIT
732    
733  dialog_main  dialog_main
734    
735  exit 0  exit 0

Legend:
Removed from v.2344  
changed lines
  Added in v.2439